/*
 * _gen/svc-Channel_Interface_Group.c - Source for TpSvcChannelInterfaceGroup
 *
 * Copyright (C) 2005, 2006 Collabora Limited
 * Copyright (C) 2005, 2006 Nokia Corporation
 * Copyright (C) 2006 INdT
 *
 * This file may be distributed under the same terms as the specification
 * from which it is generated.
 */

#include <stdio.h>
#include <stdlib.h>

#include "_gen/svc-Channel_Interface_Group.h"
#include "signals-marshal.h"
#include <telepathy-glib/dbus.h>
#include "_gen/svc-Channel_Interface_Group-glue.h"

struct _TpSvcChannelInterfaceGroupClass {
    GObjectClass parent_class;
    tp_svc_channel_interface_group_add_members_impl add_members;
    tp_svc_channel_interface_group_get_all_members_impl get_all_members;
    tp_svc_channel_interface_group_get_group_flags_impl get_group_flags;
    tp_svc_channel_interface_group_get_handle_owners_impl get_handle_owners;
    tp_svc_channel_interface_group_get_local_pending_members_impl get_local_pending_members;
    tp_svc_channel_interface_group_get_local_pending_members_with_info_impl get_local_pending_members_with_info;
    tp_svc_channel_interface_group_get_members_impl get_members;
    tp_svc_channel_interface_group_get_remote_pending_members_impl get_remote_pending_members;
    tp_svc_channel_interface_group_get_self_handle_impl get_self_handle;
    tp_svc_channel_interface_group_remove_members_impl remove_members;
};

enum {
    SIGNAL_GroupFlagsChanged,
    SIGNAL_MembersChanged,
    N_SIGNALS
};
static guint signals[N_SIGNALS] = {0};


static void
tp_svc_channel_interface_group_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;

      signals[SIGNAL_GroupFlagsChanged] =
      g_signal_new ("group-flags-changed",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    _tp_marshal_VOID__UINT_UINT,
                    G_TYPE_NONE, 2, G_TYPE_UINT, G_TYPE_UINT);

      signals[SIGNAL_MembersChanged] =
      g_signal_new ("members-changed",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    _tp_marshal_VOID__STRING_BOXED_BOXED_BOXED_BOXED_UINT_UINT,
                    G_TYPE_NONE, 7, G_TYPE_STRING, DBUS_TYPE_G_UINT_ARRAY, DBUS_TYPE_G_UINT_ARRAY, DBUS_TYPE_G_UINT_ARRAY, DBUS_TYPE_G_UINT_ARRAY, G_TYPE_UINT, G_TYPE_UINT);

      dbus_g_object_type_install_info (tp_svc_channel_interface_group_get_type(), &dbus_glib_tp_svc_channel_interface_group_object_info);
    }
}

GType
tp_svc_channel_interface_group_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0)) {
    static const GTypeInfo info = {
      sizeof (TpSvcChannelInterfaceGroupClass),
      tp_svc_channel_interface_group_base_init, /* base_init */
      NULL, /* base_finalize */
      NULL, /* class_init */
      NULL, /* class_finalize */
      NULL, /* class_data */
      0,
      0, /* n_preallocs */
      NULL /* instance_init */
    };

    type = g_type_register_static (G_TYPE_INTERFACE, "TpSvcChannelInterfaceGroup", &info, 0);
  }

  return type;
}


/**
 * tp_svc_channel_interface_group_add_members
 *
 * Implements D-Bus method AddMembers
 * on interface org.freedesktop.Telepathy.Channel.Interface.Group
 *
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 */
void
tp_svc_channel_interface_group_add_members (TpSvcChannelInterfaceGroup *self,
                                            const GArray *contacts,
                                            const gchar *message,
                                            DBusGMethodInvocation *context)
{
  tp_svc_channel_interface_group_add_members_impl impl = (TP_SVC_CHANNEL_INTERFACE_GROUP_GET_CLASS (self)->add_members);
  if (impl)
    (impl) (self, contacts, message, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

void
tp_svc_channel_interface_group_implement_add_members (TpSvcChannelInterfaceGroupClass *klass, tp_svc_channel_interface_group_add_members_impl impl)
{
  klass->add_members = impl;
}


/**
 * tp_svc_channel_interface_group_get_all_members
 *
 * Implements D-Bus method GetAllMembers
 * on interface org.freedesktop.Telepathy.Channel.Interface.Group
 *
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 */
void
tp_svc_channel_interface_group_get_all_members (TpSvcChannelInterfaceGroup *self,
                                                DBusGMethodInvocation *context)
{
  tp_svc_channel_interface_group_get_all_members_impl impl = (TP_SVC_CHANNEL_INTERFACE_GROUP_GET_CLASS (self)->get_all_members);
  if (impl)
    (impl) (self, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

void
tp_svc_channel_interface_group_implement_get_all_members (TpSvcChannelInterfaceGroupClass *klass, tp_svc_channel_interface_group_get_all_members_impl impl)
{
  klass->get_all_members = impl;
}


/**
 * tp_svc_channel_interface_group_get_group_flags
 *
 * Implements D-Bus method GetGroupFlags
 * on interface org.freedesktop.Telepathy.Channel.Interface.Group
 *
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 */
void
tp_svc_channel_interface_group_get_group_flags (TpSvcChannelInterfaceGroup *self,
                                                DBusGMethodInvocation *context)
{
  tp_svc_channel_interface_group_get_group_flags_impl impl = (TP_SVC_CHANNEL_INTERFACE_GROUP_GET_CLASS (self)->get_group_flags);
  if (impl)
    (impl) (self, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

void
tp_svc_channel_interface_group_implement_get_group_flags (TpSvcChannelInterfaceGroupClass *klass, tp_svc_channel_interface_group_get_group_flags_impl impl)
{
  klass->get_group_flags = impl;
}


/**
 * tp_svc_channel_interface_group_get_handle_owners
 *
 * Implements D-Bus method GetHandleOwners
 * on interface org.freedesktop.Telepathy.Channel.Interface.Group
 *
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 */
void
tp_svc_channel_interface_group_get_handle_owners (TpSvcChannelInterfaceGroup *self,
                                                  const GArray *handles,
                                                  DBusGMethodInvocation *context)
{
  tp_svc_channel_interface_group_get_handle_owners_impl impl = (TP_SVC_CHANNEL_INTERFACE_GROUP_GET_CLASS (self)->get_handle_owners);
  if (impl)
    (impl) (self, handles, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

void
tp_svc_channel_interface_group_implement_get_handle_owners (TpSvcChannelInterfaceGroupClass *klass, tp_svc_channel_interface_group_get_handle_owners_impl impl)
{
  klass->get_handle_owners = impl;
}


/**
 * tp_svc_channel_interface_group_get_local_pending_members
 *
 * Implements D-Bus method GetLocalPendingMembers
 * on interface org.freedesktop.Telepathy.Channel.Interface.Group
 *
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 */
void
tp_svc_channel_interface_group_get_local_pending_members (TpSvcChannelInterfaceGroup *self,
                                                          DBusGMethodInvocation *context)
{
  tp_svc_channel_interface_group_get_local_pending_members_impl impl = (TP_SVC_CHANNEL_INTERFACE_GROUP_GET_CLASS (self)->get_local_pending_members);
  if (impl)
    (impl) (self, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

void
tp_svc_channel_interface_group_implement_get_local_pending_members (TpSvcChannelInterfaceGroupClass *klass, tp_svc_channel_interface_group_get_local_pending_members_impl impl)
{
  klass->get_local_pending_members = impl;
}


/**
 * tp_svc_channel_interface_group_get_local_pending_members_with_info
 *
 * Implements D-Bus method GetLocalPendingMembersWithInfo
 * on interface org.freedesktop.Telepathy.Channel.Interface.Group
 *
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 */
void
tp_svc_channel_interface_group_get_local_pending_members_with_info (TpSvcChannelInterfaceGroup *self,
                                                                    DBusGMethodInvocation *context)
{
  tp_svc_channel_interface_group_get_local_pending_members_with_info_impl impl = (TP_SVC_CHANNEL_INTERFACE_GROUP_GET_CLASS (self)->get_local_pending_members_with_info);
  if (impl)
    (impl) (self, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

void
tp_svc_channel_interface_group_implement_get_local_pending_members_with_info (TpSvcChannelInterfaceGroupClass *klass, tp_svc_channel_interface_group_get_local_pending_members_with_info_impl impl)
{
  klass->get_local_pending_members_with_info = impl;
}


/**
 * tp_svc_channel_interface_group_get_members
 *
 * Implements D-Bus method GetMembers
 * on interface org.freedesktop.Telepathy.Channel.Interface.Group
 *
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 */
void
tp_svc_channel_interface_group_get_members (TpSvcChannelInterfaceGroup *self,
                                            DBusGMethodInvocation *context)
{
  tp_svc_channel_interface_group_get_members_impl impl = (TP_SVC_CHANNEL_INTERFACE_GROUP_GET_CLASS (self)->get_members);
  if (impl)
    (impl) (self, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

void
tp_svc_channel_interface_group_implement_get_members (TpSvcChannelInterfaceGroupClass *klass, tp_svc_channel_interface_group_get_members_impl impl)
{
  klass->get_members = impl;
}


/**
 * tp_svc_channel_interface_group_get_remote_pending_members
 *
 * Implements D-Bus method GetRemotePendingMembers
 * on interface org.freedesktop.Telepathy.Channel.Interface.Group
 *
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 */
void
tp_svc_channel_interface_group_get_remote_pending_members (TpSvcChannelInterfaceGroup *self,
                                                           DBusGMethodInvocation *context)
{
  tp_svc_channel_interface_group_get_remote_pending_members_impl impl = (TP_SVC_CHANNEL_INTERFACE_GROUP_GET_CLASS (self)->get_remote_pending_members);
  if (impl)
    (impl) (self, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

void
tp_svc_channel_interface_group_implement_get_remote_pending_members (TpSvcChannelInterfaceGroupClass *klass, tp_svc_channel_interface_group_get_remote_pending_members_impl impl)
{
  klass->get_remote_pending_members = impl;
}


/**
 * tp_svc_channel_interface_group_get_self_handle
 *
 * Implements D-Bus method GetSelfHandle
 * on interface org.freedesktop.Telepathy.Channel.Interface.Group
 *
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 */
void
tp_svc_channel_interface_group_get_self_handle (TpSvcChannelInterfaceGroup *self,
                                                DBusGMethodInvocation *context)
{
  tp_svc_channel_interface_group_get_self_handle_impl impl = (TP_SVC_CHANNEL_INTERFACE_GROUP_GET_CLASS (self)->get_self_handle);
  if (impl)
    (impl) (self, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

void
tp_svc_channel_interface_group_implement_get_self_handle (TpSvcChannelInterfaceGroupClass *klass, tp_svc_channel_interface_group_get_self_handle_impl impl)
{
  klass->get_self_handle = impl;
}


/**
 * tp_svc_channel_interface_group_remove_members
 *
 * Implements D-Bus method RemoveMembers
 * on interface org.freedesktop.Telepathy.Channel.Interface.Group
 *
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 */
void
tp_svc_channel_interface_group_remove_members (TpSvcChannelInterfaceGroup *self,
                                               const GArray *contacts,
                                               const gchar *message,
                                               DBusGMethodInvocation *context)
{
  tp_svc_channel_interface_group_remove_members_impl impl = (TP_SVC_CHANNEL_INTERFACE_GROUP_GET_CLASS (self)->remove_members);
  if (impl)
    (impl) (self, contacts, message, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

void
tp_svc_channel_interface_group_implement_remove_members (TpSvcChannelInterfaceGroupClass *klass, tp_svc_channel_interface_group_remove_members_impl impl)
{
  klass->remove_members = impl;
}

void tp_svc_channel_interface_group_emit_group_flags_changed (gpointer instance,
    const guint  added,
    const guint  removed)
{
  g_assert (TP_IS_SVC_CHANNEL_INTERFACE_GROUP (instance));
  g_signal_emit (instance, signals[SIGNAL_GroupFlagsChanged], 0, added, removed);
}

void tp_svc_channel_interface_group_emit_members_changed (gpointer instance,
    const gchar * message,
    const GArray * added,
    const GArray * removed,
    const GArray * local_pending,
    const GArray * remote_pending,
    const guint  actor,
    const guint  reason)
{
  g_assert (TP_IS_SVC_CHANNEL_INTERFACE_GROUP (instance));
  g_signal_emit (instance, signals[SIGNAL_MembersChanged], 0, message, added, removed, local_pending, remote_pending, actor, reason);
}

