/*
 * _gen/svc-Channel_Type_Streamed_Media.c - Source for TpSvcChannelTypeStreamedMedia
 *
 *  Copyright (C) 2005, 2006 Collabora Limited 
 *  Copyright (C) 2005, 2006 Nokia Corporation 
 *  Copyright (C) 2006 INdT 
 *
 * This file may be distributed under the same terms as the specification
 * from which it is generated.
 */

#include <stdio.h>
#include <stdlib.h>

#include "_gen/svc-Channel_Type_Streamed_Media.h"
#include "signals-marshal.h"
#include <telepathy-glib/dbus.h>
#include "_gen/svc-Channel_Type_Streamed_Media-glue.h"

struct _TpSvcChannelTypeStreamedMediaClass {
    GObjectClass parent_class;
    tp_svc_channel_type_streamed_media_list_streams_impl list_streams;
    tp_svc_channel_type_streamed_media_remove_streams_impl remove_streams;
    tp_svc_channel_type_streamed_media_request_stream_direction_impl request_stream_direction;
    tp_svc_channel_type_streamed_media_request_streams_impl request_streams;
};

enum {
    SIGNAL_StreamAdded,
    SIGNAL_StreamDirectionChanged,
    SIGNAL_StreamError,
    SIGNAL_StreamRemoved,
    SIGNAL_StreamStateChanged,
    N_SIGNALS
};
static guint signals[N_SIGNALS] = {0};


static void
tp_svc_channel_type_streamed_media_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;

      signals[SIGNAL_StreamAdded] =
      g_signal_new ("stream-added",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    _tp_marshal_VOID__UINT_UINT_UINT,
                    G_TYPE_NONE, 3, G_TYPE_UINT, G_TYPE_UINT, G_TYPE_UINT);

      signals[SIGNAL_StreamDirectionChanged] =
      g_signal_new ("stream-direction-changed",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    _tp_marshal_VOID__UINT_UINT_UINT,
                    G_TYPE_NONE, 3, G_TYPE_UINT, G_TYPE_UINT, G_TYPE_UINT);

      signals[SIGNAL_StreamError] =
      g_signal_new ("stream-error",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    _tp_marshal_VOID__UINT_UINT_STRING,
                    G_TYPE_NONE, 3, G_TYPE_UINT, G_TYPE_UINT, G_TYPE_STRING);

      signals[SIGNAL_StreamRemoved] =
      g_signal_new ("stream-removed",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    g_cclosure_marshal_VOID__UINT,
                    G_TYPE_NONE, 1, G_TYPE_UINT);

      signals[SIGNAL_StreamStateChanged] =
      g_signal_new ("stream-state-changed",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    _tp_marshal_VOID__UINT_UINT,
                    G_TYPE_NONE, 2, G_TYPE_UINT, G_TYPE_UINT);

      dbus_g_object_type_install_info (tp_svc_channel_type_streamed_media_get_type(), &dbus_glib_tp_svc_channel_type_streamed_media_object_info);
    }
}

GType
tp_svc_channel_type_streamed_media_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0)) {
    static const GTypeInfo info = {
      sizeof (TpSvcChannelTypeStreamedMediaClass),
      tp_svc_channel_type_streamed_media_base_init, /* base_init */
      NULL, /* base_finalize */
      NULL, /* class_init */
      NULL, /* class_finalize */
      NULL, /* class_data */
      0,
      0, /* n_preallocs */
      NULL /* instance_init */
    };

    type = g_type_register_static (G_TYPE_INTERFACE, "TpSvcChannelTypeStreamedMedia", &info, 0);
  }

  return type;
}


/**
 * tp_svc_channel_type_streamed_media_list_streams
 *
 * Implements D-Bus method ListStreams
 * on interface org.freedesktop.Telepathy.Channel.Type.StreamedMedia
 *
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 */
void
tp_svc_channel_type_streamed_media_list_streams (TpSvcChannelTypeStreamedMedia *self,
                                                 DBusGMethodInvocation *context)
{
  tp_svc_channel_type_streamed_media_list_streams_impl impl = (TP_SVC_CHANNEL_TYPE_STREAMED_MEDIA_GET_CLASS (self)->list_streams);
  if (impl)
    (impl) (self, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

void
tp_svc_channel_type_streamed_media_implement_list_streams (TpSvcChannelTypeStreamedMediaClass *klass, tp_svc_channel_type_streamed_media_list_streams_impl impl)
{
  klass->list_streams = impl;
}


/**
 * tp_svc_channel_type_streamed_media_remove_streams
 *
 * Implements D-Bus method RemoveStreams
 * on interface org.freedesktop.Telepathy.Channel.Type.StreamedMedia
 *
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 */
void
tp_svc_channel_type_streamed_media_remove_streams (TpSvcChannelTypeStreamedMedia *self,
                                                   const GArray *streams,
                                                   DBusGMethodInvocation *context)
{
  tp_svc_channel_type_streamed_media_remove_streams_impl impl = (TP_SVC_CHANNEL_TYPE_STREAMED_MEDIA_GET_CLASS (self)->remove_streams);
  if (impl)
    (impl) (self, streams, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

void
tp_svc_channel_type_streamed_media_implement_remove_streams (TpSvcChannelTypeStreamedMediaClass *klass, tp_svc_channel_type_streamed_media_remove_streams_impl impl)
{
  klass->remove_streams = impl;
}


/**
 * tp_svc_channel_type_streamed_media_request_stream_direction
 *
 * Implements D-Bus method RequestStreamDirection
 * on interface org.freedesktop.Telepathy.Channel.Type.StreamedMedia
 *
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 */
void
tp_svc_channel_type_streamed_media_request_stream_direction (TpSvcChannelTypeStreamedMedia *self,
                                                             guint stream_id,
                                                             guint stream_direction,
                                                             DBusGMethodInvocation *context)
{
  tp_svc_channel_type_streamed_media_request_stream_direction_impl impl = (TP_SVC_CHANNEL_TYPE_STREAMED_MEDIA_GET_CLASS (self)->request_stream_direction);
  if (impl)
    (impl) (self, stream_id, stream_direction, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

void
tp_svc_channel_type_streamed_media_implement_request_stream_direction (TpSvcChannelTypeStreamedMediaClass *klass, tp_svc_channel_type_streamed_media_request_stream_direction_impl impl)
{
  klass->request_stream_direction = impl;
}


/**
 * tp_svc_channel_type_streamed_media_request_streams
 *
 * Implements D-Bus method RequestStreams
 * on interface org.freedesktop.Telepathy.Channel.Type.StreamedMedia
 *
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 */
void
tp_svc_channel_type_streamed_media_request_streams (TpSvcChannelTypeStreamedMedia *self,
                                                    guint contact_handle,
                                                    const GArray *types,
                                                    DBusGMethodInvocation *context)
{
  tp_svc_channel_type_streamed_media_request_streams_impl impl = (TP_SVC_CHANNEL_TYPE_STREAMED_MEDIA_GET_CLASS (self)->request_streams);
  if (impl)
    (impl) (self, contact_handle, types, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

void
tp_svc_channel_type_streamed_media_implement_request_streams (TpSvcChannelTypeStreamedMediaClass *klass, tp_svc_channel_type_streamed_media_request_streams_impl impl)
{
  klass->request_streams = impl;
}

void tp_svc_channel_type_streamed_media_emit_stream_added (gpointer instance,
    const guint  stream_id,
    const guint  contact_handle,
    const guint  stream_type)
{
  g_assert (TP_IS_SVC_CHANNEL_TYPE_STREAMED_MEDIA (instance));
  g_signal_emit (instance, signals[SIGNAL_StreamAdded], 0, stream_id, contact_handle, stream_type);
}

void tp_svc_channel_type_streamed_media_emit_stream_direction_changed (gpointer instance,
    const guint  stream_id,
    const guint  stream_direction,
    const guint  pending_flags)
{
  g_assert (TP_IS_SVC_CHANNEL_TYPE_STREAMED_MEDIA (instance));
  g_signal_emit (instance, signals[SIGNAL_StreamDirectionChanged], 0, stream_id, stream_direction, pending_flags);
}

void tp_svc_channel_type_streamed_media_emit_stream_error (gpointer instance,
    const guint  stream_id,
    const guint  errno,
    const gchar * message)
{
  g_assert (TP_IS_SVC_CHANNEL_TYPE_STREAMED_MEDIA (instance));
  g_signal_emit (instance, signals[SIGNAL_StreamError], 0, stream_id, errno, message);
}

void tp_svc_channel_type_streamed_media_emit_stream_removed (gpointer instance,
    const guint  stream_id)
{
  g_assert (TP_IS_SVC_CHANNEL_TYPE_STREAMED_MEDIA (instance));
  g_signal_emit (instance, signals[SIGNAL_StreamRemoved], 0, stream_id);
}

void tp_svc_channel_type_streamed_media_emit_stream_state_changed (gpointer instance,
    const guint  stream_id,
    const guint  stream_state)
{
  g_assert (TP_IS_SVC_CHANNEL_TYPE_STREAMED_MEDIA (instance));
  g_signal_emit (instance, signals[SIGNAL_StreamStateChanged], 0, stream_id, stream_state);
}

