/*
 * _gen/svc-Channel_Type_Streamed_Media.h - Header for TpSvcChannelTypeStreamedMedia
 *
 *  Copyright (C) 2005, 2006 Collabora Limited 
 *  Copyright (C) 2005, 2006 Nokia Corporation 
 *  Copyright (C) 2006 INdT 
 *
 * This file may be distributed under the same terms as the specification
 * from which it is generated.
 */

#ifndef __TP_SVC_CHANNEL_TYPE_STREAMED_MEDIA_H__
#define __TP_SVC_CHANNEL_TYPE_STREAMED_MEDIA_H__

#include <glib-object.h>
#include <dbus/dbus-glib.h>

G_BEGIN_DECLS

/* dummy struct representing any implementation */
typedef struct _TpSvcChannelTypeStreamedMedia TpSvcChannelTypeStreamedMedia;

typedef struct _TpSvcChannelTypeStreamedMediaClass TpSvcChannelTypeStreamedMediaClass;


GType tp_svc_channel_type_streamed_media_get_type(void);

/* TYPE MACROS */
#define TP_TYPE_SVC_CHANNEL_TYPE_STREAMED_MEDIA \
  (tp_svc_channel_type_streamed_media_get_type())
#define TP_SVC_CHANNEL_TYPE_STREAMED_MEDIA(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), TP_TYPE_SVC_CHANNEL_TYPE_STREAMED_MEDIA, TpSvcChannelTypeStreamedMedia))
#define TP_SVC_CHANNEL_TYPE_STREAMED_MEDIA_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_CAST((klass), TP_TYPE_SVC_CHANNEL_TYPE_STREAMED_MEDIA, TpSvcChannelTypeStreamedMediaClass))
#define TP_IS_SVC_CHANNEL_TYPE_STREAMED_MEDIA(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), TP_TYPE_SVC_CHANNEL_TYPE_STREAMED_MEDIA))
#define TP_IS_SVC_CHANNEL_TYPE_STREAMED_MEDIA_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_TYPE((klass), TP_TYPE_SVC_CHANNEL_TYPE_STREAMED_MEDIA))
#define TP_SVC_CHANNEL_TYPE_STREAMED_MEDIA_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TP_TYPE_SVC_CHANNEL_TYPE_STREAMED_MEDIA, TpSvcChannelTypeStreamedMediaClass))


typedef void (*tp_svc_channel_type_streamed_media_list_streams_impl) (TpSvcChannelTypeStreamedMedia *,
                                                                      DBusGMethodInvocation *);
void tp_svc_channel_type_streamed_media_implement_list_streams (TpSvcChannelTypeStreamedMediaClass *, tp_svc_channel_type_streamed_media_list_streams_impl);


static inline void
tp_svc_channel_type_streamed_media_return_from_list_streams (DBusGMethodInvocation *dbus_context,
                                                             const GPtrArray *ret)
{
  dbus_g_method_return (dbus_context, ret);
}
void
tp_svc_channel_type_streamed_media_list_streams (TpSvcChannelTypeStreamedMedia *self,
                                                 DBusGMethodInvocation *context);

typedef void (*tp_svc_channel_type_streamed_media_remove_streams_impl) (TpSvcChannelTypeStreamedMedia *,
                                                                        const GArray *streams,
                                                                        DBusGMethodInvocation *);
void tp_svc_channel_type_streamed_media_implement_remove_streams (TpSvcChannelTypeStreamedMediaClass *, tp_svc_channel_type_streamed_media_remove_streams_impl);


static inline void
tp_svc_channel_type_streamed_media_return_from_remove_streams (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
void
tp_svc_channel_type_streamed_media_remove_streams (TpSvcChannelTypeStreamedMedia *self,
                                                   const GArray *streams,
                                                   DBusGMethodInvocation *context);

typedef void (*tp_svc_channel_type_streamed_media_request_stream_direction_impl) (TpSvcChannelTypeStreamedMedia *,
                                                                                  guint stream_id,
                                                                                  guint stream_direction,
                                                                                  DBusGMethodInvocation *);
void tp_svc_channel_type_streamed_media_implement_request_stream_direction (TpSvcChannelTypeStreamedMediaClass *, tp_svc_channel_type_streamed_media_request_stream_direction_impl);


static inline void
tp_svc_channel_type_streamed_media_return_from_request_stream_direction (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
void
tp_svc_channel_type_streamed_media_request_stream_direction (TpSvcChannelTypeStreamedMedia *self,
                                                             guint stream_id,
                                                             guint stream_direction,
                                                             DBusGMethodInvocation *context);

typedef void (*tp_svc_channel_type_streamed_media_request_streams_impl) (TpSvcChannelTypeStreamedMedia *,
                                                                         guint contact_handle,
                                                                         const GArray *types,
                                                                         DBusGMethodInvocation *);
void tp_svc_channel_type_streamed_media_implement_request_streams (TpSvcChannelTypeStreamedMediaClass *, tp_svc_channel_type_streamed_media_request_streams_impl);


static inline void
tp_svc_channel_type_streamed_media_return_from_request_streams (DBusGMethodInvocation *dbus_context,
                                                                const GPtrArray *ret)
{
  dbus_g_method_return (dbus_context, ret);
}
void
tp_svc_channel_type_streamed_media_request_streams (TpSvcChannelTypeStreamedMedia *self,
                                                    guint contact_handle,
                                                    const GArray *types,
                                                    DBusGMethodInvocation *context);

void tp_svc_channel_type_streamed_media_emit_stream_added (gpointer instance,
    const guint  stream_id,
    const guint  contact_handle,
    const guint  stream_type);

void tp_svc_channel_type_streamed_media_emit_stream_direction_changed (gpointer instance,
    const guint  stream_id,
    const guint  stream_direction,
    const guint  pending_flags);

void tp_svc_channel_type_streamed_media_emit_stream_error (gpointer instance,
    const guint  stream_id,
    const guint  errno,
    const gchar * message);

void tp_svc_channel_type_streamed_media_emit_stream_removed (gpointer instance,
    const guint  stream_id);

void tp_svc_channel_type_streamed_media_emit_stream_state_changed (gpointer instance,
    const guint  stream_id,
    const guint  stream_state);



G_END_DECLS

#endif /* #ifndef __TP_SVC_CHANNEL_TYPE_STREAMED_MEDIA_H__*/
