/*
 * _gen/svc-Connection_Interface_Avatars.c - Source for TpSvcConnectionInterfaceAvatars
 *
 *  Copyright (C) 2005, 2006 Collabora Limited 
 *  Copyright (C) 2005, 2006 Nokia Corporation 
 *  Copyright (C) 2006 INdT 
 *
 * This file may be distributed under the same terms as the specification
 * from which it is generated.
 */

#include <stdio.h>
#include <stdlib.h>

#include "_gen/svc-Connection_Interface_Avatars.h"
#include "signals-marshal.h"
#include <telepathy-glib/dbus.h>
#include "_gen/svc-Connection_Interface_Avatars-glue.h"

struct _TpSvcConnectionInterfaceAvatarsClass {
    GObjectClass parent_class;
    tp_svc_connection_interface_avatars_clear_avatar_impl clear_avatar;
    tp_svc_connection_interface_avatars_get_avatar_requirements_impl get_avatar_requirements;
    tp_svc_connection_interface_avatars_get_avatar_tokens_impl get_avatar_tokens;
    tp_svc_connection_interface_avatars_request_avatar_impl request_avatar;
    tp_svc_connection_interface_avatars_set_avatar_impl set_avatar;
};

enum {
    SIGNAL_AvatarUpdated,
    N_SIGNALS
};
static guint signals[N_SIGNALS] = {0};


static void
tp_svc_connection_interface_avatars_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;

      signals[SIGNAL_AvatarUpdated] =
      g_signal_new ("avatar-updated",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    _tp_marshal_VOID__UINT_STRING,
                    G_TYPE_NONE, 2, G_TYPE_UINT, G_TYPE_STRING);

      dbus_g_object_type_install_info (tp_svc_connection_interface_avatars_get_type(), &dbus_glib_tp_svc_connection_interface_avatars_object_info);
    }
}

GType
tp_svc_connection_interface_avatars_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0)) {
    static const GTypeInfo info = {
      sizeof (TpSvcConnectionInterfaceAvatarsClass),
      tp_svc_connection_interface_avatars_base_init, /* base_init */
      NULL, /* base_finalize */
      NULL, /* class_init */
      NULL, /* class_finalize */
      NULL, /* class_data */
      0,
      0, /* n_preallocs */
      NULL /* instance_init */
    };

    type = g_type_register_static (G_TYPE_INTERFACE, "TpSvcConnectionInterfaceAvatars", &info, 0);
  }

  return type;
}


/**
 * tp_svc_connection_interface_avatars_clear_avatar
 *
 * Implements D-Bus method ClearAvatar
 * on interface org.freedesktop.Telepathy.Connection.Interface.Avatars
 *
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 */
void
tp_svc_connection_interface_avatars_clear_avatar (TpSvcConnectionInterfaceAvatars *self,
                                                  DBusGMethodInvocation *context)
{
  tp_svc_connection_interface_avatars_clear_avatar_impl impl = (TP_SVC_CONNECTION_INTERFACE_AVATARS_GET_CLASS (self)->clear_avatar);
  if (impl)
    (impl) (self, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

void
tp_svc_connection_interface_avatars_implement_clear_avatar (TpSvcConnectionInterfaceAvatarsClass *klass, tp_svc_connection_interface_avatars_clear_avatar_impl impl)
{
  klass->clear_avatar = impl;
}


/**
 * tp_svc_connection_interface_avatars_get_avatar_requirements
 *
 * Implements D-Bus method GetAvatarRequirements
 * on interface org.freedesktop.Telepathy.Connection.Interface.Avatars
 *
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 */
void
tp_svc_connection_interface_avatars_get_avatar_requirements (TpSvcConnectionInterfaceAvatars *self,
                                                             DBusGMethodInvocation *context)
{
  tp_svc_connection_interface_avatars_get_avatar_requirements_impl impl = (TP_SVC_CONNECTION_INTERFACE_AVATARS_GET_CLASS (self)->get_avatar_requirements);
  if (impl)
    (impl) (self, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

void
tp_svc_connection_interface_avatars_implement_get_avatar_requirements (TpSvcConnectionInterfaceAvatarsClass *klass, tp_svc_connection_interface_avatars_get_avatar_requirements_impl impl)
{
  klass->get_avatar_requirements = impl;
}


/**
 * tp_svc_connection_interface_avatars_get_avatar_tokens
 *
 * Implements D-Bus method GetAvatarTokens
 * on interface org.freedesktop.Telepathy.Connection.Interface.Avatars
 *
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 */
void
tp_svc_connection_interface_avatars_get_avatar_tokens (TpSvcConnectionInterfaceAvatars *self,
                                                       const GArray *contacts,
                                                       DBusGMethodInvocation *context)
{
  tp_svc_connection_interface_avatars_get_avatar_tokens_impl impl = (TP_SVC_CONNECTION_INTERFACE_AVATARS_GET_CLASS (self)->get_avatar_tokens);
  if (impl)
    (impl) (self, contacts, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

void
tp_svc_connection_interface_avatars_implement_get_avatar_tokens (TpSvcConnectionInterfaceAvatarsClass *klass, tp_svc_connection_interface_avatars_get_avatar_tokens_impl impl)
{
  klass->get_avatar_tokens = impl;
}


/**
 * tp_svc_connection_interface_avatars_request_avatar
 *
 * Implements D-Bus method RequestAvatar
 * on interface org.freedesktop.Telepathy.Connection.Interface.Avatars
 *
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 */
void
tp_svc_connection_interface_avatars_request_avatar (TpSvcConnectionInterfaceAvatars *self,
                                                    guint contact,
                                                    DBusGMethodInvocation *context)
{
  tp_svc_connection_interface_avatars_request_avatar_impl impl = (TP_SVC_CONNECTION_INTERFACE_AVATARS_GET_CLASS (self)->request_avatar);
  if (impl)
    (impl) (self, contact, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

void
tp_svc_connection_interface_avatars_implement_request_avatar (TpSvcConnectionInterfaceAvatarsClass *klass, tp_svc_connection_interface_avatars_request_avatar_impl impl)
{
  klass->request_avatar = impl;
}


/**
 * tp_svc_connection_interface_avatars_set_avatar
 *
 * Implements D-Bus method SetAvatar
 * on interface org.freedesktop.Telepathy.Connection.Interface.Avatars
 *
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 */
void
tp_svc_connection_interface_avatars_set_avatar (TpSvcConnectionInterfaceAvatars *self,
                                                const GArray *avatar,
                                                const gchar *mime_type,
                                                DBusGMethodInvocation *context)
{
  tp_svc_connection_interface_avatars_set_avatar_impl impl = (TP_SVC_CONNECTION_INTERFACE_AVATARS_GET_CLASS (self)->set_avatar);
  if (impl)
    (impl) (self, avatar, mime_type, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

void
tp_svc_connection_interface_avatars_implement_set_avatar (TpSvcConnectionInterfaceAvatarsClass *klass, tp_svc_connection_interface_avatars_set_avatar_impl impl)
{
  klass->set_avatar = impl;
}

void tp_svc_connection_interface_avatars_emit_avatar_updated (gpointer instance,
    const guint  contact,
    const gchar * new_avatar_token)
{
  g_assert (TP_IS_SVC_CONNECTION_INTERFACE_AVATARS (instance));
  g_signal_emit (instance, signals[SIGNAL_AvatarUpdated], 0, contact, new_avatar_token);
}

