/*
 * _gen/svc-Connection_Interface_Avatars.h - Header for TpSvcConnectionInterfaceAvatars
 *
 *  Copyright (C) 2005, 2006 Collabora Limited 
 *  Copyright (C) 2005, 2006 Nokia Corporation 
 *  Copyright (C) 2006 INdT 
 *
 * This file may be distributed under the same terms as the specification
 * from which it is generated.
 */

#ifndef __TP_SVC_CONNECTION_INTERFACE_AVATARS_H__
#define __TP_SVC_CONNECTION_INTERFACE_AVATARS_H__

#include <glib-object.h>
#include <dbus/dbus-glib.h>

G_BEGIN_DECLS

/* dummy struct representing any implementation */
typedef struct _TpSvcConnectionInterfaceAvatars TpSvcConnectionInterfaceAvatars;

typedef struct _TpSvcConnectionInterfaceAvatarsClass TpSvcConnectionInterfaceAvatarsClass;


GType tp_svc_connection_interface_avatars_get_type(void);

/* TYPE MACROS */
#define TP_TYPE_SVC_CONNECTION_INTERFACE_AVATARS \
  (tp_svc_connection_interface_avatars_get_type())
#define TP_SVC_CONNECTION_INTERFACE_AVATARS(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), TP_TYPE_SVC_CONNECTION_INTERFACE_AVATARS, TpSvcConnectionInterfaceAvatars))
#define TP_SVC_CONNECTION_INTERFACE_AVATARS_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_CAST((klass), TP_TYPE_SVC_CONNECTION_INTERFACE_AVATARS, TpSvcConnectionInterfaceAvatarsClass))
#define TP_IS_SVC_CONNECTION_INTERFACE_AVATARS(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), TP_TYPE_SVC_CONNECTION_INTERFACE_AVATARS))
#define TP_IS_SVC_CONNECTION_INTERFACE_AVATARS_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_TYPE((klass), TP_TYPE_SVC_CONNECTION_INTERFACE_AVATARS))
#define TP_SVC_CONNECTION_INTERFACE_AVATARS_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TP_TYPE_SVC_CONNECTION_INTERFACE_AVATARS, TpSvcConnectionInterfaceAvatarsClass))


typedef void (*tp_svc_connection_interface_avatars_clear_avatar_impl) (TpSvcConnectionInterfaceAvatars *,
                                                                       DBusGMethodInvocation *);
void tp_svc_connection_interface_avatars_implement_clear_avatar (TpSvcConnectionInterfaceAvatarsClass *, tp_svc_connection_interface_avatars_clear_avatar_impl);


static inline void
tp_svc_connection_interface_avatars_return_from_clear_avatar (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
void
tp_svc_connection_interface_avatars_clear_avatar (TpSvcConnectionInterfaceAvatars *self,
                                                  DBusGMethodInvocation *context);

typedef void (*tp_svc_connection_interface_avatars_get_avatar_requirements_impl) (TpSvcConnectionInterfaceAvatars *,
                                                                                  DBusGMethodInvocation *);
void tp_svc_connection_interface_avatars_implement_get_avatar_requirements (TpSvcConnectionInterfaceAvatarsClass *, tp_svc_connection_interface_avatars_get_avatar_requirements_impl);


static inline void
tp_svc_connection_interface_avatars_return_from_get_avatar_requirements (DBusGMethodInvocation *dbus_context,
                                                                         const gchar **ret,
                                                                         guint ret1,
                                                                         guint ret2,
                                                                         guint ret3,
                                                                         guint ret4,
                                                                         guint ret5)
{
  dbus_g_method_return (dbus_context, ret, ret1, ret2, ret3, ret4, ret5);
}
void
tp_svc_connection_interface_avatars_get_avatar_requirements (TpSvcConnectionInterfaceAvatars *self,
                                                             DBusGMethodInvocation *context);

typedef void (*tp_svc_connection_interface_avatars_get_avatar_tokens_impl) (TpSvcConnectionInterfaceAvatars *,
                                                                            const GArray *contacts,
                                                                            DBusGMethodInvocation *);
void tp_svc_connection_interface_avatars_implement_get_avatar_tokens (TpSvcConnectionInterfaceAvatarsClass *, tp_svc_connection_interface_avatars_get_avatar_tokens_impl);


static inline void
tp_svc_connection_interface_avatars_return_from_get_avatar_tokens (DBusGMethodInvocation *dbus_context,
                                                                   const gchar **ret)
{
  dbus_g_method_return (dbus_context, ret);
}
void
tp_svc_connection_interface_avatars_get_avatar_tokens (TpSvcConnectionInterfaceAvatars *self,
                                                       const GArray *contacts,
                                                       DBusGMethodInvocation *context);

typedef void (*tp_svc_connection_interface_avatars_request_avatar_impl) (TpSvcConnectionInterfaceAvatars *,
                                                                         guint contact,
                                                                         DBusGMethodInvocation *);
void tp_svc_connection_interface_avatars_implement_request_avatar (TpSvcConnectionInterfaceAvatarsClass *, tp_svc_connection_interface_avatars_request_avatar_impl);


static inline void
tp_svc_connection_interface_avatars_return_from_request_avatar (DBusGMethodInvocation *dbus_context,
                                                                const GArray *ret,
                                                                const gchar *ret1)
{
  dbus_g_method_return (dbus_context, ret, ret1);
}
void
tp_svc_connection_interface_avatars_request_avatar (TpSvcConnectionInterfaceAvatars *self,
                                                    guint contact,
                                                    DBusGMethodInvocation *context);

typedef void (*tp_svc_connection_interface_avatars_set_avatar_impl) (TpSvcConnectionInterfaceAvatars *,
                                                                     const GArray *avatar,
                                                                     const gchar *mime_type,
                                                                     DBusGMethodInvocation *);
void tp_svc_connection_interface_avatars_implement_set_avatar (TpSvcConnectionInterfaceAvatarsClass *, tp_svc_connection_interface_avatars_set_avatar_impl);


static inline void
tp_svc_connection_interface_avatars_return_from_set_avatar (DBusGMethodInvocation *dbus_context,
                                                            const gchar *ret)
{
  dbus_g_method_return (dbus_context, ret);
}
void
tp_svc_connection_interface_avatars_set_avatar (TpSvcConnectionInterfaceAvatars *self,
                                                const GArray *avatar,
                                                const gchar *mime_type,
                                                DBusGMethodInvocation *context);

void tp_svc_connection_interface_avatars_emit_avatar_updated (gpointer instance,
    const guint  contact,
    const gchar * new_avatar_token);



G_END_DECLS

#endif /* #ifndef __TP_SVC_CONNECTION_INTERFACE_AVATARS_H__*/
