/*
 * _gen/svc-Connection_Manager.h - Header for TpSvcConnectionManager
 *
 * Copyright (C) 2005, 2006 Collabora Limited
 * Copyright (C) 2005, 2006 Nokia Corporation
 * Copyright (C) 2006 INdT
 *
 * This file may be distributed under the same terms as the specification
 * from which it is generated.
 */

#ifndef __TP_SVC_CONNECTION_MANAGER_H__
#define __TP_SVC_CONNECTION_MANAGER_H__

#include <glib-object.h>
#include <dbus/dbus-glib.h>

G_BEGIN_DECLS

/* dummy struct representing any implementation */
typedef struct _TpSvcConnectionManager TpSvcConnectionManager;

typedef struct _TpSvcConnectionManagerClass TpSvcConnectionManagerClass;


GType tp_svc_connection_manager_get_type(void);

/* TYPE MACROS */
#define TP_TYPE_SVC_CONNECTION_MANAGER \
  (tp_svc_connection_manager_get_type())
#define TP_SVC_CONNECTION_MANAGER(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), TP_TYPE_SVC_CONNECTION_MANAGER, TpSvcConnectionManager))
#define TP_SVC_CONNECTION_MANAGER_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_CAST((klass), TP_TYPE_SVC_CONNECTION_MANAGER, TpSvcConnectionManagerClass))
#define TP_IS_SVC_CONNECTION_MANAGER(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), TP_TYPE_SVC_CONNECTION_MANAGER))
#define TP_IS_SVC_CONNECTION_MANAGER_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_TYPE((klass), TP_TYPE_SVC_CONNECTION_MANAGER))
#define TP_SVC_CONNECTION_MANAGER_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TP_TYPE_SVC_CONNECTION_MANAGER, TpSvcConnectionManagerClass))


typedef void (*tp_svc_connection_manager_get_parameters_impl) (TpSvcConnectionManager *,
                                                               const gchar *proto,
                                                               DBusGMethodInvocation *);
void tp_svc_connection_manager_implement_get_parameters (TpSvcConnectionManagerClass *, tp_svc_connection_manager_get_parameters_impl);


static inline void
tp_svc_connection_manager_return_from_get_parameters (DBusGMethodInvocation *dbus_context,
                                                      const GPtrArray *ret)
{
  dbus_g_method_return (dbus_context, ret);
}
void
tp_svc_connection_manager_get_parameters (TpSvcConnectionManager *self,
                                          const gchar *proto,
                                          DBusGMethodInvocation *context);

typedef void (*tp_svc_connection_manager_list_protocols_impl) (TpSvcConnectionManager *,
                                                               DBusGMethodInvocation *);
void tp_svc_connection_manager_implement_list_protocols (TpSvcConnectionManagerClass *, tp_svc_connection_manager_list_protocols_impl);


static inline void
tp_svc_connection_manager_return_from_list_protocols (DBusGMethodInvocation *dbus_context,
                                                      const gchar **ret)
{
  dbus_g_method_return (dbus_context, ret);
}
void
tp_svc_connection_manager_list_protocols (TpSvcConnectionManager *self,
                                          DBusGMethodInvocation *context);

typedef void (*tp_svc_connection_manager_request_connection_impl) (TpSvcConnectionManager *,
                                                                   const gchar *proto,
                                                                   GHashTable *parameters,
                                                                   DBusGMethodInvocation *);
void tp_svc_connection_manager_implement_request_connection (TpSvcConnectionManagerClass *, tp_svc_connection_manager_request_connection_impl);


static inline void
tp_svc_connection_manager_return_from_request_connection (DBusGMethodInvocation *dbus_context,
                                                          const gchar *ret,
                                                          const gchar *ret1)
{
  dbus_g_method_return (dbus_context, ret, ret1);
}
void
tp_svc_connection_manager_request_connection (TpSvcConnectionManager *self,
                                              const gchar *proto,
                                              GHashTable *parameters,
                                              DBusGMethodInvocation *context);

void tp_svc_connection_manager_emit_new_connection (gpointer instance,
    const gchar * bus_name,
    const gchar * object_path,
    const gchar * proto);



G_END_DECLS

#endif /* #ifndef __TP_SVC_CONNECTION_MANAGER_H__*/
