/*
 * _gen/svc-Media_Session_Handler.h - Header for TpSvcMediaSessionHandler
 *
 *  Copyright (C) 2005, 2006 Collabora Limited 
 *  Copyright (C) 2005, 2006 Nokia Corporation 
 *  Copyright (C) 2006 INdT 
 *
 * This file may be distributed under the same terms as the specification
 * from which it is generated.
 */

#ifndef __TP_SVC_MEDIA_SESSION_HANDLER_H__
#define __TP_SVC_MEDIA_SESSION_HANDLER_H__

#include <glib-object.h>
#include <dbus/dbus-glib.h>

G_BEGIN_DECLS

/* dummy struct representing any implementation */
typedef struct _TpSvcMediaSessionHandler TpSvcMediaSessionHandler;

typedef struct _TpSvcMediaSessionHandlerClass TpSvcMediaSessionHandlerClass;


GType tp_svc_media_session_handler_get_type(void);

/* TYPE MACROS */
#define TP_TYPE_SVC_MEDIA_SESSION_HANDLER \
  (tp_svc_media_session_handler_get_type())
#define TP_SVC_MEDIA_SESSION_HANDLER(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), TP_TYPE_SVC_MEDIA_SESSION_HANDLER, TpSvcMediaSessionHandler))
#define TP_SVC_MEDIA_SESSION_HANDLER_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_CAST((klass), TP_TYPE_SVC_MEDIA_SESSION_HANDLER, TpSvcMediaSessionHandlerClass))
#define TP_IS_SVC_MEDIA_SESSION_HANDLER(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), TP_TYPE_SVC_MEDIA_SESSION_HANDLER))
#define TP_IS_SVC_MEDIA_SESSION_HANDLER_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_TYPE((klass), TP_TYPE_SVC_MEDIA_SESSION_HANDLER))
#define TP_SVC_MEDIA_SESSION_HANDLER_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TP_TYPE_SVC_MEDIA_SESSION_HANDLER, TpSvcMediaSessionHandlerClass))


typedef void (*tp_svc_media_session_handler_error_impl) (TpSvcMediaSessionHandler *,
                                                         guint errno,
                                                         const gchar *message,
                                                         DBusGMethodInvocation *);
void tp_svc_media_session_handler_implement_error (TpSvcMediaSessionHandlerClass *, tp_svc_media_session_handler_error_impl);


static inline void
tp_svc_media_session_handler_return_from_error (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
void
tp_svc_media_session_handler_error (TpSvcMediaSessionHandler *self,
                                    guint errno,
                                    const gchar *message,
                                    DBusGMethodInvocation *context);

typedef void (*tp_svc_media_session_handler_ready_impl) (TpSvcMediaSessionHandler *,
                                                         DBusGMethodInvocation *);
void tp_svc_media_session_handler_implement_ready (TpSvcMediaSessionHandlerClass *, tp_svc_media_session_handler_ready_impl);


static inline void
tp_svc_media_session_handler_return_from_ready (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
void
tp_svc_media_session_handler_ready (TpSvcMediaSessionHandler *self,
                                    DBusGMethodInvocation *context);

void tp_svc_media_session_handler_emit_new_stream_handler (gpointer instance,
    const gchar * stream_handler,
    const guint  id,
    const guint  media_type,
    const guint  direction);



G_END_DECLS

#endif /* #ifndef __TP_SVC_MEDIA_SESSION_HANDLER_H__*/
