/*
 * _gen/svc-Media_Stream_Handler.h - Header for TpSvcMediaStreamHandler
 *
 *  Copyright (C) 2005, 2006 Collabora Limited 
 *  Copyright (C) 2005, 2006 Nokia Corporation 
 *  Copyright (C) 2006 INdT 
 *
 * This file may be distributed under the same terms as the specification
 * from which it is generated.
 */

#ifndef __TP_SVC_MEDIA_STREAM_HANDLER_H__
#define __TP_SVC_MEDIA_STREAM_HANDLER_H__

#include <glib-object.h>
#include <dbus/dbus-glib.h>

G_BEGIN_DECLS

/* dummy struct representing any implementation */
typedef struct _TpSvcMediaStreamHandler TpSvcMediaStreamHandler;

typedef struct _TpSvcMediaStreamHandlerClass TpSvcMediaStreamHandlerClass;


GType tp_svc_media_stream_handler_get_type(void);

/* TYPE MACROS */
#define TP_TYPE_SVC_MEDIA_STREAM_HANDLER \
  (tp_svc_media_stream_handler_get_type())
#define TP_SVC_MEDIA_STREAM_HANDLER(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), TP_TYPE_SVC_MEDIA_STREAM_HANDLER, TpSvcMediaStreamHandler))
#define TP_SVC_MEDIA_STREAM_HANDLER_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_CAST((klass), TP_TYPE_SVC_MEDIA_STREAM_HANDLER, TpSvcMediaStreamHandlerClass))
#define TP_IS_SVC_MEDIA_STREAM_HANDLER(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), TP_TYPE_SVC_MEDIA_STREAM_HANDLER))
#define TP_IS_SVC_MEDIA_STREAM_HANDLER_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_TYPE((klass), TP_TYPE_SVC_MEDIA_STREAM_HANDLER))
#define TP_SVC_MEDIA_STREAM_HANDLER_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TP_TYPE_SVC_MEDIA_STREAM_HANDLER, TpSvcMediaStreamHandlerClass))


typedef void (*tp_svc_media_stream_handler_codec_choice_impl) (TpSvcMediaStreamHandler *,
                                                               guint codec_id,
                                                               DBusGMethodInvocation *);
void tp_svc_media_stream_handler_implement_codec_choice (TpSvcMediaStreamHandlerClass *, tp_svc_media_stream_handler_codec_choice_impl);


static inline void
tp_svc_media_stream_handler_return_from_codec_choice (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
void
tp_svc_media_stream_handler_codec_choice (TpSvcMediaStreamHandler *self,
                                          guint codec_id,
                                          DBusGMethodInvocation *context);

typedef void (*tp_svc_media_stream_handler_error_impl) (TpSvcMediaStreamHandler *,
                                                        guint errno,
                                                        const gchar *message,
                                                        DBusGMethodInvocation *);
void tp_svc_media_stream_handler_implement_error (TpSvcMediaStreamHandlerClass *, tp_svc_media_stream_handler_error_impl);


static inline void
tp_svc_media_stream_handler_return_from_error (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
void
tp_svc_media_stream_handler_error (TpSvcMediaStreamHandler *self,
                                   guint errno,
                                   const gchar *message,
                                   DBusGMethodInvocation *context);

typedef void (*tp_svc_media_stream_handler_native_candidates_prepared_impl) (TpSvcMediaStreamHandler *,
                                                                             DBusGMethodInvocation *);
void tp_svc_media_stream_handler_implement_native_candidates_prepared (TpSvcMediaStreamHandlerClass *, tp_svc_media_stream_handler_native_candidates_prepared_impl);


static inline void
tp_svc_media_stream_handler_return_from_native_candidates_prepared (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
void
tp_svc_media_stream_handler_native_candidates_prepared (TpSvcMediaStreamHandler *self,
                                                        DBusGMethodInvocation *context);

typedef void (*tp_svc_media_stream_handler_new_active_candidate_pair_impl) (TpSvcMediaStreamHandler *,
                                                                            const gchar *native_candidate_id,
                                                                            const gchar *remote_candidate_id,
                                                                            DBusGMethodInvocation *);
void tp_svc_media_stream_handler_implement_new_active_candidate_pair (TpSvcMediaStreamHandlerClass *, tp_svc_media_stream_handler_new_active_candidate_pair_impl);


static inline void
tp_svc_media_stream_handler_return_from_new_active_candidate_pair (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
void
tp_svc_media_stream_handler_new_active_candidate_pair (TpSvcMediaStreamHandler *self,
                                                       const gchar *native_candidate_id,
                                                       const gchar *remote_candidate_id,
                                                       DBusGMethodInvocation *context);

typedef void (*tp_svc_media_stream_handler_new_native_candidate_impl) (TpSvcMediaStreamHandler *,
                                                                       const gchar *candidate_id,
                                                                       const GPtrArray *transports,
                                                                       DBusGMethodInvocation *);
void tp_svc_media_stream_handler_implement_new_native_candidate (TpSvcMediaStreamHandlerClass *, tp_svc_media_stream_handler_new_native_candidate_impl);


static inline void
tp_svc_media_stream_handler_return_from_new_native_candidate (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
void
tp_svc_media_stream_handler_new_native_candidate (TpSvcMediaStreamHandler *self,
                                                  const gchar *candidate_id,
                                                  const GPtrArray *transports,
                                                  DBusGMethodInvocation *context);

typedef void (*tp_svc_media_stream_handler_ready_impl) (TpSvcMediaStreamHandler *,
                                                        const GPtrArray *codecs,
                                                        DBusGMethodInvocation *);
void tp_svc_media_stream_handler_implement_ready (TpSvcMediaStreamHandlerClass *, tp_svc_media_stream_handler_ready_impl);


static inline void
tp_svc_media_stream_handler_return_from_ready (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
void
tp_svc_media_stream_handler_ready (TpSvcMediaStreamHandler *self,
                                   const GPtrArray *codecs,
                                   DBusGMethodInvocation *context);

typedef void (*tp_svc_media_stream_handler_set_local_codecs_impl) (TpSvcMediaStreamHandler *,
                                                                   const GPtrArray *codecs,
                                                                   DBusGMethodInvocation *);
void tp_svc_media_stream_handler_implement_set_local_codecs (TpSvcMediaStreamHandlerClass *, tp_svc_media_stream_handler_set_local_codecs_impl);


static inline void
tp_svc_media_stream_handler_return_from_set_local_codecs (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
void
tp_svc_media_stream_handler_set_local_codecs (TpSvcMediaStreamHandler *self,
                                              const GPtrArray *codecs,
                                              DBusGMethodInvocation *context);

typedef void (*tp_svc_media_stream_handler_stream_state_impl) (TpSvcMediaStreamHandler *,
                                                               guint state,
                                                               DBusGMethodInvocation *);
void tp_svc_media_stream_handler_implement_stream_state (TpSvcMediaStreamHandlerClass *, tp_svc_media_stream_handler_stream_state_impl);


static inline void
tp_svc_media_stream_handler_return_from_stream_state (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
void
tp_svc_media_stream_handler_stream_state (TpSvcMediaStreamHandler *self,
                                          guint state,
                                          DBusGMethodInvocation *context);

typedef void (*tp_svc_media_stream_handler_supported_codecs_impl) (TpSvcMediaStreamHandler *,
                                                                   const GPtrArray *codecs,
                                                                   DBusGMethodInvocation *);
void tp_svc_media_stream_handler_implement_supported_codecs (TpSvcMediaStreamHandlerClass *, tp_svc_media_stream_handler_supported_codecs_impl);


static inline void
tp_svc_media_stream_handler_return_from_supported_codecs (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
void
tp_svc_media_stream_handler_supported_codecs (TpSvcMediaStreamHandler *self,
                                              const GPtrArray *codecs,
                                              DBusGMethodInvocation *context);

void tp_svc_media_stream_handler_emit_add_remote_candidate (gpointer instance,
    const gchar * candidate_id,
    const GPtrArray * transports);

void tp_svc_media_stream_handler_emit_close (gpointer instance);

void tp_svc_media_stream_handler_emit_remove_remote_candidate (gpointer instance,
    const gchar * candidate_id);

void tp_svc_media_stream_handler_emit_set_active_candidate_pair (gpointer instance,
    const gchar * native_candidate_id,
    const gchar * remote_candidate_id);

void tp_svc_media_stream_handler_emit_set_remote_candidate_list (gpointer instance,
    const GPtrArray * remote_candidates);

void tp_svc_media_stream_handler_emit_set_remote_codecs (gpointer instance,
    const GPtrArray * codecs);

void tp_svc_media_stream_handler_emit_set_stream_playing (gpointer instance,
    const gboolean  playing);

void tp_svc_media_stream_handler_emit_set_stream_sending (gpointer instance,
    const gboolean  playing);



G_END_DECLS

#endif /* #ifndef __TP_SVC_MEDIA_STREAM_HANDLER_H__*/
